'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _reduxDevtoolsThemes = require('redux-devtools-themes');

var themes = _interopRequireWildcard(_reduxDevtoolsThemes);

var _reduxDevtools = require('redux-devtools');

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _reducers = require('./reducers');

var _reducers2 = _interopRequireDefault(_reducers);

var _Chart = require('./Chart');

var _Chart2 = _interopRequireDefault(_Chart);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var reset = _reduxDevtools.ActionCreators.reset;
var rollback = _reduxDevtools.ActionCreators.rollback;
var commit = _reduxDevtools.ActionCreators.commit;
var sweep = _reduxDevtools.ActionCreators.sweep;
var toggleAction = _reduxDevtools.ActionCreators.toggleAction;

var styles = {
  container: {
    fontFamily: 'monaco, Consolas, Lucida Console, monospace',
    position: 'relative',
    overflowY: 'hidden',
    width: '100%',
    height: '100%',
    minWidth: 300
  }
};

var ChartMonitor = (function (_Component) {
  _inherits(ChartMonitor, _Component);

  function ChartMonitor(props) {
    _classCallCheck(this, ChartMonitor);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ChartMonitor).call(this, props));

    _this.shouldComponentUpdate = _function2.default;

    _this.handleToggleAction = _this.handleToggleAction.bind(_this);
    _this.handleReset = _this.handleReset.bind(_this);
    _this.handleRollback = _this.handleRollback.bind(_this);
    _this.handleSweep = _this.handleSweep.bind(_this);
    _this.handleCommit = _this.handleCommit.bind(_this);
    return _this;
  }

  _createClass(ChartMonitor, [{
    key: 'handleRollback',
    value: function handleRollback() {
      this.props.dispatch(rollback());
    }
  }, {
    key: 'handleSweep',
    value: function handleSweep() {
      this.props.dispatch(sweep());
    }
  }, {
    key: 'handleCommit',
    value: function handleCommit() {
      this.props.dispatch(commit());
    }
  }, {
    key: 'handleToggleAction',
    value: function handleToggleAction(id) {
      this.props.dispatch(toggleAction(id));
    }
  }, {
    key: 'handleReset',
    value: function handleReset() {
      this.props.dispatch(reset());
    }
  }, {
    key: 'getTheme',
    value: function getTheme() {
      var theme = this.props.theme;

      if (typeof theme !== 'string') {
        return theme;
      }

      if (typeof themes[theme] !== 'undefined') {
        return themes[theme];
      }

      console.warn('DevTools theme ' + theme + ' not found, defaulting to nicinabox');
      return themes.nicinabox;
    }
  }, {
    key: 'getChartStyle',
    value: function getChartStyle() {
      var theme = this.getTheme();

      return {
        width: '100%',
        height: '100%',
        node: {
          colors: {
            'default': theme.base0B,
            collapsed: theme.base0B,
            parent: theme.base0E
          },
          radius: 7
        },
        text: {
          colors: {
            'default': theme.base0D,
            hover: theme.base06
          }
        }
      };
    }
  }, {
    key: 'getChartOptions',
    value: function getChartOptions() {
      var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
      var computedStates = props.computedStates;

      var defaultOptions = {
        state: computedStates[computedStates.length - 1].state,
        isSorted: false,
        heightBetweenNodesCoeff: 1,
        widthBetweenNodesCoeff: 1.3,
        tooltipOptions: { disabled: true },
        style: this.getChartStyle()
      };

      return (0, _deepmerge2.default)(defaultOptions, props);
    }
  }, {
    key: 'render',
    value: function render() {
      var theme = this.getTheme();

      return _react2.default.createElement(
        'div',
        { style: _extends({}, styles.container, { backgroundColor: theme.base00 }) },
        _react2.default.createElement(_Chart2.default, this.getChartOptions())
      );
    }
  }]);

  return ChartMonitor;
})(_react.Component);

ChartMonitor.reducer = _reducers2.default;
ChartMonitor.propTypes = {
  dispatch: _react.PropTypes.func,
  computedStates: _react.PropTypes.array,
  actionsById: _react.PropTypes.object,
  stagedActionIds: _react.PropTypes.array,
  skippedActionIds: _react.PropTypes.array,
  monitorState: _react.PropTypes.shape({
    initialScrollTop: _react.PropTypes.number
  }),

  preserveScrollTop: _react.PropTypes.bool,
  select: _react.PropTypes.func.isRequired,
  theme: _react.PropTypes.oneOfType([_react.PropTypes.object, _react.PropTypes.string])
};
ChartMonitor.defaultProps = {
  select: function select(state) {
    return state;
  },
  theme: 'nicinabox',
  preserveScrollTop: true
};
exports.default = ChartMonitor;